package com.liang.dao;

import com.liang.entity.BaseSubjectname;
import com.liang.entity.BaseTitle;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (BaseSubjectname)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-04 10:54:02
 */
public interface BaseSubjectnameDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    BaseSubjectname queryById(String id);

    /**
     * 查询指定行数据
     *
     * @return 对象列表
     */
    List<BaseSubjectname> queryAllByLimit(BaseSubjectname baseSubjectname, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param baseSubjectname 查询条件
     * @return 总行数
     */
    long count(BaseSubjectname baseSubjectname);

    /**
     * 新增数据
     *
     * @param baseSubjectname 实例对象
     * @return 影响行数
     */
    int insert(BaseSubjectname baseSubjectname);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseSubjectname> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BaseSubjectname> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseSubjectname> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<BaseSubjectname> entities);

    /**
     * 修改数据
     *
     * @param baseSubjectname 实例对象
     * @return 影响行数
     */
    int update(BaseSubjectname baseSubjectname);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(String id);

    /**
     * 获取所有数据
     *
     * @return
     */
    List<BaseSubjectname> queryAll();

    /**
     * 查询满足条件的记录
     *
     * @param id
     * @return
     */
    List<BaseSubjectname> queryListById(String id);

    /**
     * 获取学科分类列表
     *
     * @return
     */
    List<Map<String, String>> getSubjectList();
}

